//! @file $RCSfile: lin_lib.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: lin_lib.h,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

#ifndef _LIN_LIB_H_
#define _LIN_LIB_H_

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lib_mcu/lin_uart/lin_drv_usart.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

#if LIN_CONFIG == 1				// 1:]u, 0:呕u
#include "lib_mcu/lin_uart/slave_lin.h"
#else
#include "lib_mcu/lin_uart/master_lin.h"
#endif

//_____ ϸ ____________________________________________________________________

//!
//! @defgroup lin_command_status_define LINߏԒl`
//! LINߏԗpޯĒ`
//! @{
#define LIN_CMD_REFUSED		0		// 
#define LIN_CMD_ACCEPTED	1		// 󂯓
//!@}

//!
//! @defgroup lin_status_define LINԒl`
//! _lin_statuspޯĒ`
//! @{
#define LIN_STATUS_RX		0x01	// ްM튮׸
#define LIN_STATUS_TX		0x02	// ްM튮׸
#define LIN_STATUS_ID		0x04	// ʎq튮׸
#define LIN_STATUS_ERR		0x08	// ُ픭׸
#define LIN_STATUS_BUSY		0x10	// Z׸
//! @}

//_____ 錾 ___________________________________________________________________

//!< ̗񋓂st_cmd_lin_t\̂̎wүސ錾ɑ΂銈ÎɎgp܂B
typedef enum {
  LIN_CMD_M_NONE,				// ߂Ȃ
  LIN_CMD_M_TX,					// 呕uM(ڰѐ擪+)
  LIN_CMD_M_RX,					// 呕uM(ڰѐ擪)+呕uM()
  LIN_CMD_S_RX,					// ]uM(ڰѐ擪+)
  LIN_CMD_S_TX,					// ]uM(ڰѐ擪)+]uM()
  LIN_CMD_SLP,					// x~(L)
  LIN_CMD_WUP					// N
} lin_cmd_t;

//!< ̗񋓂͑M̋NIɎgp܂(IAۂȂ)B
typedef enum {
  TX_EVENT,						// 
  TX_PERIODICALLY,				// I
  Tx_DELAY						// xt
} lin_trigger_t;

//!< ̗񋓂lin_getstatus̖߂lʂɎgp܂B
typedef enum {
  LIN_AVAILABLE,					// p\Ԕԍ
  LIN_ACTION_COMPLETED,				// Ԕԍ
  LIN_ID_RECEIVED,					// ʎqMԔԍ
  LIN_ACTION_ONGOING,				// isԔԍ
  LIN_ERROR_BIT = 0xC1,				// ޯČԔԍ
  LIN_ERROR_CSUM = 0xC2,			// ьԔԍ
  LIN_ERROR_PARITY = 0xC4,			// èԔԍ
  LIN_ERROR_SYNCHRO = 0xC8,			// ُԔԍ
  LIN_ERROR_NO_ACTIVITY = 0xD0,		// ޽ȂԔԍ
  LIN_ERROR_NO_RESPONDING = 0xE0,	// ]uԔԍ
  LIN_SLEEP_MODE = 0xF0				// x~Ԕԍ
} lin_status_t;

//!< ̍\̂LINүޒ`܂B
typedef  struct{
  U8 id;					// DLC܂ގʎq
  U8* pt_data;				// ްւ߲
} st_lin_t;

//!< ̍\̂LINԂł̎w芈`܂B
typedef  struct{
  U8 handle;				// ߏ׸
  lin_cmd_t cmd;			// ߌ`
  st_lin_t* pt_lin_msg;		// үގeւ߲
} st_cmd_lin_t;

U8 lin_init (void);
U8 lin_cmd (st_cmd_lin_t* pt_cmd);
lin_status_t lin_getstatus (st_cmd_lin_t* pt_cmd);
U8 nb_byte_to_lin_dlc(U8 dlc_trame);
U8 lin_dlc_to_nb_byte(U8 nb_byte);

U8 LIN_CalcChecksum (void);
U8 LIN_InitIdField(U8 lin_id ) ;
void Lin_hw_init(void);

#endif /* _LIN_LIB_H_ */
