//! @file $RCSfile: lin_lib.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: lin_lib.c,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lin_lib.h"
#include "lin_drv_usart.h"

//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
	extern volatile U8  Timer_IC_cnt;		//!< ߊl͎یv
	extern volatile U8 _lin_synchronized;	//!< LIN呕uƂ̓(1=2%)
#endif

//_____ 錾 ___________________________________________________________________

//! ̊֐LIN܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
U8 lin_init (void)
{
  Lin_hw_init();				// LINʰ޳
  Lin_set_baudrate();			// LINްڰĐݒ
  Lin_clear_status() ;			// LIN׸ޏ

#ifdef _COUNTING_ERRORS_ENABLE
  countCERR=0;					// ьv평
  countRERR=0;					// ]uُv평(呕û)
  countBERR=0;					// ޯĈُv평
  countSERR=0;					// ُv평
  countPERR=0;					// èv
#endif

#ifdef _SLEEP_TIMOUT_DETECTION
  LINSleepFlag = 0;				// x~Ԓ׸ޏ
#if LIN_CONFIG == 1				// 1:]u, 0:呕u
  SleepCtr = 0;					// x~Ԓߌv평
  NoBusActivityFlag= 0;			// (2500ޯĎ)޽Ȃ׸ޏ
  MyCpuIsSleepingFlag = 0;		// MCUذߓ쒆׸ޏ
#endif
#endif

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
  _lin_synchronized = 0;		// LIN呕uƂ̓׸މ
#endif

#if LIN_CONFIG == 0				// 1:]u, 0:呕u
  LIN_TIMER_init();				// LIN֘Av평/n(v(tick)֐)
#endif
  return TRUE;
}

//! LIN߉ߕłB
//!
//! @warning :
//!
//! @param	pt_cmd	st_cmd_lin_t^̖߈ʒuwq
//!
//! @return	ߏԂԂ܂B
//!			LIN_CMD_ACCEPTED
//!			LIN_CMD_REFUSED
//!
U8 lin_cmd (st_cmd_lin_t* pt_cmd) {
  U8 status;
  U8 cpt, temp;

  if ((pt_cmd->cmd ==LIN_CMD_S_TX) &&(pt_cmd->handle == 1)){	// ]uMLŁA
	temp = lin_dlc_to_nb_byte(pt_cmd->pt_lin_msg->id >> 4);		// ް ޲Đ擾
	Lin_reset_index();											// ޲Čv평
	for (cpt=0; cpt < temp; cpt++){								// Mް
	  Lin_set_data(*(pt_cmd->pt_lin_msg->pt_data + cpt));		// ΉMް ޲ĕ
	}
	Lin_cmds_txdata();											// ]uްM(Ԑݒ,э쐬)
	status = LIN_CMD_ACCEPTED;									// ߎ󂯓׸ސݒ
  }else if ( Lin_get_busy() ){									// Z()ŁA
	status = LIN_CMD_REFUSED;									// ߋۏ׸ސݒ
  } else{														// Z()ȊOŁA
	status = LIN_CMD_ACCEPTED;									// ߎ󂯓׸ސݒ
	Lin_clear_status();											// LIN׸މ
	Lin_clear_error_status();									// LINُ׸މ
	switch(pt_cmd->cmd){
	case LIN_CMD_M_TX:											// 呕uMŁA
	  pt_cmd->handle = 1;										// L׸ސݒ
	  temp = lin_dlc_to_nb_byte(pt_cmd->pt_lin_msg->id >> 4);	// ް ޲Đ擾
	  Lin_reset_index();										// ޲Čv평
	  for (cpt=0; cpt < temp; cpt++){							// Mް
		Lin_set_data(*(pt_cmd->pt_lin_msg->pt_data + cpt));		// ΉMް ޲ĕ
	  }
	  Lin_set_id(pt_cmd->pt_lin_msg->id);						// ʎq
	  Lin_cmdm_txdata();										// 呕uްM(Ԑݒ,э쐬)
	  break;

	case LIN_CMD_M_RX:							// 呕uMŁA
	  pt_cmd->handle = 1;						// L׸ސݒ
	  Lin_set_id(pt_cmd->pt_lin_msg->id);		// ʎq
	  Lin_cmdm_rxdata();						// 呕uްM(Ԑݒ蓙)
	  break;

	case LIN_CMD_S_RX:							// ]uMŁA
	  pt_cmd->handle = 1;						// L׸ސݒ
	  Lin_cmds_rxdata();						// ]uްM(Ԑݒ蓙)
	  break;

	case LIN_CMD_WUP:
	  pt_cmd->handle = 1;						// L׸ސݒ
	  Lin_cmds_wkup();							// NMo
	  break;

	case LIN_CMD_SLP:
	  pt_cmd->handle = 1;						// L׸ސݒ
	  Lin_cmds_wkup();							// NMo
	  break;

	default:
	  break;
	}
  }
  return(status);								// ԔԍƋɕA
}

//! ̊֐LIN̏ԂԂ܂B
//!
//! @warning :
//!
//! @param	pt_cmd	st_cmd_lin_t^̖߈ʒuwq
//!
//! @return	ߏԂԂ܂B
//!			LIN_AVAILABLE
//!			LIN_ACTION_COMPLETED
//!			LIN_ID_RECEIVED
//!			LIN_ACTION_ONGOING
//!
lin_status_t lin_getstatus (st_cmd_lin_t* pt_cmd){
  lin_status_t status;
  U8 temp;
  U8 cpt;

  if (0 == pt_cmd->handle){						// ȂŁA
	status = LIN_AVAILABLE;						// p\Ԕԍݒ
  }else{										// ŁA
	temp = Lin_get_status();					// ڰѐis׸ޒl擾
	if (temp == LIN_STATUS_TX){					// ްM튮ŁA
	  pt_cmd->handle = 0;						// ߏ׸މ
	  Lin_clear_status();						// LIN׸މ
	  status = LIN_ACTION_COMPLETED;			// Ԕԍݒ
	}else if (temp == LIN_STATUS_RX){			// ްM튮ŁA
	  pt_cmd->handle = 0;						// ߏ׸މ
	  Lin_clear_status();						// LIN׸މ
	  temp = lin_dlc_to_nb_byte(pt_cmd->pt_lin_msg->id >> 4);	// ް ޲Đ擾
	  Lin_reset_index();						// ޲Čv평
	  for ( cpt=0 ; cpt<temp ; cpt++){			// Mް
		*(pt_cmd->pt_lin_msg->pt_data + cpt ) = Lin_get_data();	// ΉMް ޲ĕ
		Lin_inc_index();						// ޲Čvis
	  }
	  status = LIN_ACTION_COMPLETED;			// Ԕԍݒ
	}else if (temp == LIN_STATUS_ID){			// ʎq튮ŁA
	  pt_cmd->handle = 1;						// ߏ׸ސݒ
	  Lin_clear_status();						// LIN׸މ
	  pt_cmd->pt_lin_msg->id = Lin_get_id();	// Mʎq
	  status = LIN_ID_RECEIVED;					// ʎqMԔԍݒ
	}else if (temp == LIN_STATUS_ERR){			// ُ픭ŁA
	  pt_cmd->handle = 0;						// ߏ׸މ
	  Lin_clear_status();						// LIN׸މ
	  status = (lin_status_t)(0xC0 + Lin_get_error());	// ΉُԔԍݒ
	  Lin_clear_error_status();					// LINُ׸މ
	}else if (temp == LIN_STATUS_BUSY){			// ZŁA
	  status =LIN_ACTION_ONGOING;				// isԔԍݒ
	}else{										// ̑ŁA
	  if (_lin_state == 0) {					// ۂ̏ȂŁA
		status =  LIN_AVAILABLE;				// p\Ԕԍݒ
	  }
	}
  }
  return (status);								// ԔԍƋɕA
}

//! ̊֐͎ʎqDLCΉ޲Đɕϊ܂B
//!
//! @warning :
//!
//! @param	dlc_field	LINDLC̈(00:2޲,01:2޲,10:4޲,11:8޲)
//!
//! @return	޲ĐԂ܂B
//!
U8 lin_dlc_to_nb_byte(U8 dlc_field){
  U8 nb_byte;

  if (dlc_field < 2){							// DLC=00܂01ŁA
	nb_byte = 2;								// ޲Đ=2
  }else if (2 == dlc_field){					// DLC=10ŁA
	nb_byte = 4;								// ޲Đ=4
  }else{										// DLC=11ŁA
	nb_byte = 8;								// ޲Đ=8
  }
  return nb_byte;								// ޲ĐƋɕA
}

//! ̊֐޲ĐɑΉDLCɕϊ܂B
//!
//! @warning :
//!
//! @param	nb_byte	޲Đ(2,4܂8)
//!
//! @return	LINDLC̈Ԃ܂B
//!
U8 nb_byte_to_lin_dlc(U8 nb_byte){
  U8 lin_dlc;

  if (nb_byte <= 2){							// 2޲ĈȉŁA
	lin_dlc = 0;								// DLC=00
  }else if (nb_byte <= 4){						// 4޲ĂŁA
	lin_dlc = 2;								// DLC=10
  }else{										// ̑(8޲)ŁA
	lin_dlc = 3;								// DLC=11
  }
  return lin_dlc;								// DLClƋɕA
}

//! LINްɏՕeɊтvZ܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	LINї̈Ԃ܂B
//!
U8 LIN_CalcChecksum (void){
  U16	uiResult = 0x0000;
  U8	index;

  for(index = 0; index < _lin_index; index++) {
	uiResult += _lin_tab_data[index];			// ώZ
	uiResult += ((uiResult & 0x100) >> 8);		// ޲ĈꕪZ
	uiResult &= 0x00FF;							// ޲Ĉ
  }
  return (unsigned char)(~(uiResult & 0x00ff));	// тƋɕA(LlޯĒPʘ_])
}

//! ̊֐͎ʎqè ޯĂǉ܂B
//!
//! @warning :
//!
//! @param	lin_id	è ޯĂȂLINʎq
//!
//! @return	è ޯĕtLINʎqԂ܂B
//!
U8 LIN_InitIdField(U8 lin_id ){
  U8	LINParity0;
  U8	LINParity1;
  U8	LinIdField;

  LinIdField = lin_id & 0x3F;					// ʎq޲Ăè ޯĈʒu
  LINParity0 = (								// P0=D0 XOR D1 XOR D2 XOR D4
				(LinIdField & 0x01)
				  ^
					((LinIdField & 0x02) >> 1)
					  ^
						((LinIdField & 0x04) >> 2 )
						  ^
							((LinIdField & 0x10) >> 4)
							  );

  LINParity1 = ( !(								// P1=D1 XOR D3 XOR D4 XOR D5
				   ((LinIdField & 0x02) >> 1)
					 ^
					   ((LinIdField & 0x08) >> 3)
						 ^
						   ((LinIdField & 0x10) >> 4)
							 ^
							   ((LinIdField & 0x20) >> 5)
								 )
				);

  LinIdField |=  ((LINParity1 & 0x01) << 7)|((LINParity0 & 0x01) << 6);	// ʎq޲Ăè ޯč
  return LinIdField;							// ètʎq޲ĂƋɕA
}
