//! @file $RCSfile: timer2_lib.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name:  $ $Id: timer2_lib.c,v 1.1.1.1 2006/08/10 14:02:18 gallain Exp $
//!
//! @todo Test todo
//! @bug Test bug

//_____ ݸٰ ________________________________________________________________
#include "lib_mcu/timer/timer2_lib.h"

//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________
extern U8 timout_ovf_cnt;		// T/C2gޯ(2400bps,8޲Čvp)

#ifdef _TIMOUT_DETECTION
  #ifdef DYNAMIC_BAUDRATE
	extern U16 UART_BAUDRATE_SYNC;
	extern U16 UART_BAUDRATE_NORM;
	extern U16 UART_BAUDRATE_SYNC_MASTER;
	extern U16 TIMEOUT_M_HEADER;
	extern U16 TIMEOUT_S_HEADER;
	extern U16 TIMEOUT_RESPONSE_2DATA;
	extern U16 TIMEOUT_RESPONSE_4DATA;
	extern U16 TIMEOUT_RESPONSE_8DATA;
	extern U16 TIMER_2_PRESCALER;
  #else
	#ifndef TIMER_2_PRESCALER
	  #error "timer 2 prescaler not defined"
	#endif
  #endif

//_____ 錾 ___________________________________________________________________

//! ̊֐ްɏ]ĎԒ߂o邽߂/2n܂B
//!
//! @warning :
//!
//! @param	timeout	Ԍo߂ɐ旧҂
//! @param	dlc		LINް(2,4,8ŗL蓾܂B)
//!
//! @return	Ȃ
//!
void Timer2_start(U16 timout,U8 dlc){
  TIMSK2 = 1 << TOIE2;			// T/C2ꊄ荞݋

#if LIN_BAUDRATE == 2400
  if (dlc == 8 ) {				// 8޲ ްŁA
	timout_ovf_cnt = FALSE;		// T/C2ł̎Ԓߌow
  }else{						// 2܂4޲ ްŁA
	timout_ovf_cnt = TRUE;		// T/C2ł̎ԒߌoLw
  }
#endif

  TCNT2 = timout;			// 1ޯĎԂňlݒ

  if(TIMER_2_PRESCALER == 256){
#if defined(__AVR_AT90CAN128__) | defined(__AT90CAN128__)
  TCCR2A = (1<<CS22)  | (1<<CS21);				// 256OuT/C2n
#else
  TCCR2B = (1<<CS22)  | (1<<CS21);				// 256OuT/C2n
#endif
  }

  else if(TIMER_2_PRESCALER == 1024){
#if defined(__AVR_AT90CAN128__) | defined(__AT90CAN128__)
  TCCR2A = (1<<CS22)  | (1<<CS21) | (1<<CS20);	// 1024OuT/C2n
#else
  TCCR2B = (1<<CS22)  | (1<<CS21) | (1<<CS20);	// 1024OuT/C2n
#endif
  }
}

//! ̊֐/2~߂܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void Timer2_stop(void){
  TIMSK2  &= ~(1 << TOIE2);		// T/C2ꊄ荞݋֎~
#if defined(__AVR_AT90CAN128__) | defined(__AT90CAN128__)
  TCCR2A  = 0x00;				// T/C2~
#else
  TCCR2B  = 0x00;				// T/C2~
#endif
}
#endif
